extends KinematicBody

var target = null
var speed = 60
var tpath = PoolVector3Array()
const BOUY_RANGE = -3
const GRAB_RANGE = 64

export(bool) var is_crying = false

## MOVEMENT
func get_dir_heading(a,b):#Get the direction based on to points heading.
	var dir = Vector3()
	dir.x =  clamp(a.x-b.x,-1,1)
	dir.z =  clamp(a.z-b.z,-1,1)
	return dir

func walkpath(delta):#Walks along a path
	if(tpath.size()>0):
		var dir = Vector3()
		if(target.global_transform.origin.distance_to(global_transform.origin) < GRAB_RANGE):#Within grabbing distance forget pathfinding for a bit.
			print_debug(target.global_transform.origin.distance_to(global_transform.origin))
			dir = get_dir_heading(target.global_transform.origin,global_transform.origin)
			look_at(Vector3(target.global_transform.origin.x,0,target.global_transform.origin.z),Vector3(0,1,0))
		else:#Nah just follow the yella brick road
			dir = get_dir_heading(tpath[0],global_transform.origin)
			look_at(Vector3(tpath[0].x,0,tpath[0].z),Vector3(0,1,0))
		var colid = move_and_collide(dir*delta*speed)
		if(abs(tpath[0].x)-abs(global_transform.origin.x) > BOUY_RANGE):
			if(abs(tpath[0].z)-abs(global_transform.origin.z) > BOUY_RANGE):
				tpath.remove(0)
		$AnimationPlayer.play("walk")
		if(colid != null):
			if(colid.collider == target):
				colid.collider.gameover()
			elif(colid.collider.name == "GridMap"):#You are bumping into a wall
				global_transform.origin += dir
	else:
		create_path(global_transform.origin,target.global_transform.origin)

func create_path(from,to):#Forms the walk path
#FIRST ESTABLISH THE POINTS
	var nav = get_parent()
	var grid = nav.get_node("GridMap")
	var mlib =  grid.mesh_library
	var floo = PoolVector3Array()
	for f in grid.get_used_cells():
		var fname = mlib.get_item_name(grid.get_cell_item(f.x,f.y,f.z))
		if(fname == "floor"):
			floo.append(f)
	from = nav.get_closest_point(from)
	from = grid.world_to_map(from)
	to = nav.get_closest_point(to)
	to = grid.world_to_map(to)
#SECONDLY ESTABLISH THE START AND END OF THE PATH
	if(to != Vector3(0,0,0)):#HOTFIX i have no idea why onready it's 0,0,0
		to = compare_closest_point(floo,to)
		from = compare_closest_point(floo,from)

#THIRD CREATE THE PATH
		var newpath = chase(from,to,floo)
		#Strange GODOt navigation bug. nav.get_simple_path() does not display a path beyond one nav mesh.
		tpath = PoolVector3Array()
		for n in newpath:
			tpath.append(grid.map_to_world(n.x,n.y,n.z))
#		print_debug(tpath)

func compare_closest_point(pointlist,finder,direction = Vector3()):#Find the point in the array that is the closest to the finder
	var closest = pointlist[0]
	if((closest==finder)&&pointlist.size()>1):
		closest = pointlist[1]
	for p in pointlist:
		var olddis = closest.distance_to(finder)
		var newdis = p.distance_to(finder+direction)
		if(newdis<olddis):
			if(direction == Vector3(0,0,0)):#If there is no preferred direction, then it should not matter if p and finder are the same.
				closest = p
			else:
				if(p!=finder):
					closest = p
	return closest

## BRAIN
func chase(from,to,aviable):#A path toward the player
	var newpath = PoolVector3Array([from])
	for p in aviable.size():#Paths can only go as big as the amount of points aviable.
		var direction = get_dir_heading(to,newpath[newpath.size()-1])
		var newpoint = compare_closest_point(aviable,newpath[newpath.size()-1],direction)
		if(newpoint==to):#Reached the 'to' point, no need to go further
			break
		else:
			if(newpoint!=newpath[newpath.size()-1]):
				newpath.append(newpoint)
	newpath.append(to)
	print_debug(newpath)
	return newpath

## HAND 
func grab(body):#If the hand has grabbed something
	if(body == target):
		target.gameover()

## MAIN
func _physics_process(delta):
	if(is_instance_valid(target)):
		walkpath(delta)

func _ready():
	if(has_node("../player")):
		target = get_node("../player")
	if(is_crying):
		set_physics_process(false)
		$AnimationPlayer.play("cry")
	print_debug($crookmesh/sp1/body/arm/elbow/hand.connect("body_entered",self,"grab"))