extends KinematicBody

var speed = 4000
var sensitivity = 0.01

var orbscollected = 0
const MAXORBS = 15

## Movement
func walk(delta):#Go around stuff, like corners
	var dir = Vector3()
	if(Input.is_action_pressed("ui_left")):
		dir -= $Camera.transform.basis.x
	elif(Input.is_action_pressed("ui_right")):
		dir += $Camera.transform.basis.x
	elif(Input.is_action_pressed("ui_up")):
		dir -= $Camera.transform.basis.z
	elif(Input.is_action_pressed("ui_down")):
		dir += $Camera.transform.basis.z
	move_and_slide(dir*delta*speed)

## GAMEOVER
func gameover():
	get_tree().reload_current_scene()

func collect_orb():
	orbscollected += 1
	if(orbscollected>MAXORBS):
		win()

func win():#YAY you won!
	get_tree().change_scene("res://levels/winscreen.tscn")

## MAIN
func _physics_process(delta):
	walk(delta)

func _input(event):
	if(event.get_class() == "InputEventMouseMotion"):
		$Camera.rotate_y(-event.relative.x*sensitivity)
	elif(event.is_action_pressed("ui_cancel")):
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)
		get_tree().quit()

func _ready():
	Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
	$AnimationPlayer.play("gg")